(c-declare #<<END-C
#include <stdio.h>
#include <string.h>
END-C
)

(c-define (read-some-stuff ctx len) 
          (scheme-object int) scheme-object
          "read_some_stuff" "static"
 (with-exception-catcher
   (lambda (exn)
     (display "*** ERROR " (current-error-port))
     (display-exception exn (current-error-port))
     '#!eof)
   (lambda ()
     (let* ((port (##vector-ref ctx 0))
            (buf  (##vector-ref ctx 1)))
       (if (or (not buf) (##fx< (##u8vector-length buf) len))
         (let ((buf* (##make-u8vector len)))
           (set! buf buf*)
           (##vector-set! ctx 1 buf*)))
       
       (display #\.)
       
       (let ((rlen (##read-subu8vector buf 0 len port)))
         (cond 
          ((##fxzero? rlen) '#!eof) 
          ((##fx< rlen len) (##u8vector-shrink! buf rlen))
          (else buf)))))))

(c-declare #<<END-C
static int do_read (void* ctx, char *buf, int len) {
  ___SCMOBJ data = read_some_stuff ((___SCMOBJ)ctx, len);
  if (___EOFP (data)) {
    return -1;
  } else {
    memmove (buf, ___CAST (___U8*, ___BODY_AS (data, ___tSUBTYPED)),
                  ___HD_BYTES (___HEADER (data)));
    return ___HD_BYTES (___HEADER (data));
  }
}
END-C
)

(define do-read
  (c-lambda (scheme-object) int
       #<<END-C
char buf[4096];
___SCMOBJ ctx = ___EXT(___make_vector)(2, ___FAL, ___STILL);
___VECTORSET (ctx, ___FIX(0), ___arg1);

for (;;) {
  if (do_read ((void*)ctx, buf, sizeof(buf)) < 0) break;
}
END-C
))

(define (run)
  (let ((port (open-input-file "/dev/zero")))
    (do-read port)))

(define (main)
  (let ((thr1 (thread-start! (make-thread run)))
        (thr2 (thread-start! (make-thread run))))
    (thread-sleep! +inf.0)))
